
%% ESR (no SIF yet) incl. CBFS / augmentation

augTest=6; fpool=5; regular=1.5;

visualise=true; %set false if no figures should appear
% generate mean shape and k-means cluster centres
mean_shape=mean(lm_train,3); augment=80; 
num_ferns_M=500;
[idx,C]=kmeans(reshape(lm_train,166*2,[])',5);
kmeans_cluster=reshape(C',166,2,5);
%rand_shape=mean_shape;%
nu_train=124;

%inital (augmented) trainings shapes are called 'updated'
updated=reshape(lm_train(:,:,randi(nu_train,[nu_train*augment,1])),166,2,nu_train,augment);
if augment==1
    updated=repmat(mean_shape,1,1,nu_train);
end

%inital (k-means + mean-shape) test shapes are called 'updated_test'
updated_test=zeros(166,2,123,augTest);
updated_test(:,:,:,1)=repmat(mean(lm_train,3),1,1,123);
updated_test(:,:,:,2:6)=repmat(permute(kmeans_cluster,[1,2,4,3]),1,1,123,1);
%% repeat for ten stages
for iter=1:10
    
    offset=randn(166,fpool*2)*512*0.05;
    % set updated training shapes as new initialisation

    rand_shape=updated;
    % sampling of features in training images
    feat_x=zeros(166*fpool,nu_train,augment);
    feat_y=zeros(166*fpool,nu_train,augment);
    for f=1:fpool
        feat_x((f-1)*166+1:f*166,:,:)=permute(rand_shape(:,1,:,:),[1,3,4,2])+repmat(offset(:,f),1,nu_train,augment);
        feat_y((f-1)*166+1:f*166,:,:)=permute(rand_shape(:,2,:,:),[1,3,4,2])+repmat(offset(:,f+fpool),1,nu_train,augment);
    end
    
    feat_ind=sub2ind([1024,1024,nu_train],round(min(max(feat_y,1),1024)),...
        round(min(max(feat_x,1),1024)),repmat((1:nu_train),166*fpool,1,augment));
    
    features=img_train_filt(feat_ind);
    % landmark regression target
    lm_trainR=reshape(lm_train(:,:,1:nu_train),166*2,[]);
    target=repmat(lm_trainR,1,1,augment)-reshape(rand_shape,166*2,nu_train,augment);
    
    % train random ferns
    [ferns,ysPr,inds_m,inds_n,loss] = fernsRegTrainCBFS(double(reshape(features,166*fpool,[])'),double(reshape(target,166*2,[])'),'M',num_ferns_M,'S',5,'reg',regular,'R',1,'thrr',[-150,150]);
    norm(double(reshape(target,166*2,[])')-ysPr)
    % plot loss function of ferns
   % hold on; plot(loss);
    ysR=reshape(ysPr',166,2,nu_train,augment);
    
    
    if(visualise)
    subplot(1,3,1); imagesc(img_train(:,:,1)); axis image; title('pixel sampling for image features');
     hold on; plot(lm_train(:,1,1),lm_train(:,2,1),'sr'); axis image;
     for a=1:augment
     hold on; plot(ysR(:,1,1,a)+rand_shape(:,1,1,a),ysR(:,2,1,a)+rand_shape(:,2,1,a),'.w'); axis image;
     end
    end
    
    % set updated training shapes as new initialisation
    updated=rand_shape+reshape(ysPr',166,2,nu_train,augment);
    
    % create sampling for feature pool if test images
    init_test=updated_test;%updated_test=repmat(mean(lm_train,3),1,1,123);
    
    feat_x=zeros(166*fpool,123,augTest);
    feat_y=zeros(166*fpool,123,augTest);
    for f=1:fpool
        feat_x((f-1)*166+1:f*166,:,:)=permute(init_test(:,1,:,:),[1,3,4,2])+repmat(offset(:,f),1,123,augTest);
        feat_y((f-1)*166+1:f*166,:,:)=permute(init_test(:,2,:,:),[1,3,4,2])+repmat(offset(:,f+fpool),1,123,augTest);
    end
    feat_ind=sub2ind([1024,1024,123],round(min(max(feat_y,1),1024)),...
        round(min(max(feat_x,1),1024)),repmat((1:123),166*fpool,1,augTest));
    features_test=img_test_filt(feat_ind);
    
    % apply ferns to test images
    tic;
    [ysTest] = fernsRegApplyCBFS(double(reshape(features_test,166*fpool,[])'),ferns,inds_m,inds_n);%double(features_test')
    toc;
    all_test{iter}=init_test;
    
    updated_test=init_test+reshape(ysTest',166,2,123,augTest);
    tre=squeeze(mean(sqrt(sum((lm_test-updated_test(:,:,:,1)).^2,2)),1));
    
    %norm(target_test_gt-reshape(updated_test,166*2,123)')
    
    ysTestR=reshape(ysTest',166,2,123,augTest);
    ysTestR=ysTestR(:,:,:,1);
    if (visualise)
        subplot(1,3,2); hold on; plot(loss); title('regression loss');
         
        
        testNu=2;
        subplot(1,3,3); imagesc(img_test(:,:,testNu)); axis image;
        hold on; plot(init_test(:,1,testNu),init_test(:,2,testNu),'sw'); title('GT(red cross), initialisation and estimation white');
        hold on; plot(init_test(:,1,testNu)+ysTestR(:,1,testNu),init_test(:,2,testNu)+ysTestR(:,2,testNu),'+w');
        hold on; plot(lm_test(:,1,testNu),lm_test(:,2,testNu),'.r');   drawnow;
        
    end
    % eval (only mean-shape)
    errs_mm=0.5*distanceJSRT(lm_test,updated_test(:,:,:,1))+0.5*distanceJSRT(updated_test(:,:,:,1),lm_test);
    errs_mm_all{iter}=errs_mm;
    
    % eval with 6 initial shapes
    result_median=median(updated_test,4);
    errs_mm=0.5*distanceJSRT(lm_test,result_median)+0.5*distanceJSRT(result_median,lm_test);
    errs_mm_median{iter}=errs_mm;
       mean(errs_mm,2)

    
end
%
disp('=== FINISHED. FINAL ERROR in mm for (all structures,');
disp('r/l lung, heart, r/l clavicles) is: ====');
       mean(errs_mm,2)
